<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>Trajectory - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="DistanceType.html">DistanceType</a><ul class='members'></ul></li><li><a href="InequalityType.html">InequalityType</a><ul class='members'></ul></li><li><a href="QLearner.html">QLearner</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="QLearner.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#setParameters">setParameters</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#getQtable">getQtable</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#doAction">doAction</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#doNext">doNext</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#doPath">doPath</a></li><li data-type='method' style='display: none;'><a href="QLearner.html#.newQLearner">newQLearner</a></li></ul></li><li><a href="ScalarField.html">ScalarField</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ScalarField.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#setParameters">setParameters</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#set">set</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#erase">erase</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#add">add</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#load">load</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#save">save</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getValues">getValues</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#has">has</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#get">get</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getValue">getValue</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getExtrapolations">getExtrapolations</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getBarycenter">getBarycenter</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getDiameter">getDiameter</a></li><li data-type='method' style='display: none;'><a href="ScalarField.html#getDistance">getDistance</a></li></ul></li><li><a href="Trajectory.html">Trajectory</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Trajectory.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#setParameters">setParameters</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#addPoint">addPoint</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#addRegion">addRegion</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#add">add</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#getNext">getNext</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#isDone">isDone</a></li><li data-type='method' style='display: none;'><a href="Trajectory.html#getPath">getPath</a></li></ul></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">Trajectory</h1>
    

    




<section>

<header>
    
        <h2>
        
            Trajectory
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="Trajectory"><span class="type-signature"></span>new Trajectory<span class="signature">(parameters)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements a trajectory generator on a symboling space.</p>
<p><a name="parameters"></a></p>
<h2>Trajectory parameters</h2>
<h3>General parameter</h3>
<ul>
<li><code>type: ...</code> The type element used to calculate the distance, mandatory, default is &quot;value&quot;.</li>
<li><code>epsilon: ...</code> The minimal distance between to indistinguishable value, default is near, i.e., <code>1e-12</code>.
<ul>
<li>If <code>d(current, goal) &lt; epsilon</code> the goal is supposed to be reached.</li>
<li>If <code>d(current, obstacle) &lt; epsilon</code> the obstacle is supposed to be hit, generating an error.</li>
</ul>
</li>
<li><code>step: ...</code> The neighborhood minimal weighted distance to an obstacle, default is 1.</li>
<li><code>d_max: ...</code> The maximal distance for extrapolation away from obstacle, default is no bound.</li>
<li><code>nu_max: ...</code> The maximal deviation from a geodesic regarding extrapolation, default is no bound.</li>
<li><code>bounds_count: ...</code> The maximal number of bounds to take into account for extrapolation, default is 0 (i.e., all bounds).</li>
<li><code>w_max: ...</code> The maximal repulsion weight to avoid an obstacle, default is 1/near, i.e., <code>1e+12</code>.</li>
<li><code>points</code>: Optionally defines trajectory weighted (corresponding to the output) points:</li>
</ul>
<pre class="prettyprint source"><code>points : [
  { input: ... output: ... }
  ../..
]
</code></pre>
<ul>
<li><code>regions</code>: Optionally defines trajectory weighted (corresponding to the output) regions, i.e., obstacles, defined by types:</li>
</ul>
<pre class="prettyprint source"><code>regions : [
  { name: ... type: ... output: ... type_parameter: ... }
  ../..
]
</code></pre>
<ul>
<li><code>verbose: ...</code> If true print the trajectory steps on stdout. Default is false.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>
|

<span class="param-type">String</span>



            
            </td>

            

            

            <td class="description last"><p>The trajectory parameters.</p></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="getParameters"><span class="type-signature"></span>getParameters<span class="signature">()</span><span class="type-signature"> &rarr; {JSON}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the trajectory parameters.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The trajectory parameters.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">JSON</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="setParameters"><span class="type-signature"></span>setParameters<span class="signature">(parameters)</span><span class="type-signature"> &rarr; {<a href="Trajectory.html">Trajectory</a>}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Modifies some Trajectory parameters.</p>
<ul>
<li>All parameters but the <code>type</code> can be modified.</li>
<li>The Trajectory points are preserved when changing the parameters, thus using the <code>points</code> field simply adds the points.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>



            
            </td>

            

            

            <td class="description last"><p>The Trajectory parameters.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>This value allowing to chain methods.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type"><a href="Trajectory.html">Trajectory</a></span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="addPoint"><span class="type-signature"></span>addPoint<span class="signature">(value, weight)</span><span class="type-signature"> &rarr; {<a href="Trajectory.html">Trajectory</a>}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Adds/Erases a punctual goal or a constraint for this trajectory.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>value</code></td>
            

            <td class="type">
            
                
<span class="param-type">Value</span>



            
            </td>

            

            

            <td class="description last"><p>A goal or constraint to add, as punctual value.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>weight</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            

            

            <td class="description last"><p>The element weight or relative reward.</p>
<ul>
<li><code>&gt; 0</code> If the point belongs to a goal. The highest the value, the more the goal importance.</li>
<li><code>&lt; 0</code> If the point belongs to a constraint or obstacle to avoid.</li>
<li><code>= 0</code> If the point is to be deleted.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>This value allowing to chain add methods.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type"><a href="Trajectory.html">Trajectory</a></span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="addRegion"><span class="type-signature"></span>addRegion<span class="signature">(value, weight)</span><span class="type-signature"> &rarr; {<a href="Trajectory.html">Trajectory</a>}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Adds/Erases a regaion goal or a constraint for this trajectory.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>value</code></td>
            

            <td class="type">
            
                
<span class="param-type">Type</span>



            
            </td>

            

            

            <td class="description last"><p>A goal or constraint to add, as a region defined by a type.</p>
<ul>
<li>By contract a Type is remament, i.e., it is NOT deleted during the program execution.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>weight</code></td>
            

            <td class="type">
            
                
<span class="param-type">double</span>



            
            </td>

            

            

            <td class="description last"><p>The element weight or relative reward.</p>
<ul>
<li><code>&gt; 0</code> If the point belongs to a goal. The highest the value, the more the goal importance.</li>
<li><code>&lt; 0</code> If the point belongs to a constraint or obstacle to avoid.</li>
<li><code>= 0</code> If the point is to be deleted.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>This value allowing to chain add methods.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type"><a href="Trajectory.html">Trajectory</a></span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="add"><span class="type-signature"></span>add<span class="signature">(values)</span><span class="type-signature"> &rarr; {<a href="Trajectory.html">Trajectory</a>}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Adds all values trajectory values.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>values</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>
|

<span class="param-type">String</span>



            
            </td>

            

            

            <td class="description last"><p>The trajectory points or regions values.</p>
<ul>
<li>The trajectory points's type must be compatible (i.e., the same type or a derived type) of this scalar value type.</li>
<li>It can also be defined as a JSON unordered list of value of syntax:</li>
</ul>
<pre class="prettyprint source"><code>[
  { input: ... output: ... } // for a point
  { type: ... output: ... type_parameter: ... } // for a region
  ../..
]
</code></pre>
<p>where <code>input</code> stands for the trajectory point, <code>type</code> for the region predefined type (adding type parameters if required), and <code>output</code> for the related weight.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>This value allowing to chain add methods.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type"><a href="Trajectory.html">Trajectory</a></span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getNext"><span class="type-signature"></span>getNext<span class="signature">(current<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {Value}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Gets the next point on the trajectory.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>current</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>
|

<span class="param-type">String</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            

            <td class="description last"><p>The actual state value.</p>
<ul>
<li>If omitted considers the previous returned value.</li>
<li>If specified then reset the trajectory.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>














<h5 class="h5-throws">Throws:</h5>

        

    <div class="param-desc usertext">
    
        <p>An <code>illegal-argument</code> exception if at the beginning the value was already on a obstacle.</p>
    
    </div>


    


<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The next value on the trajectory towards a goal, avoiding obstacles. Returns the current value if already on a goal.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Value</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="isDone"><span class="type-signature"></span>isDone<span class="signature">()</span><span class="type-signature"> &rarr; {bool}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Checks if a goal has been attained.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>True if the last current value obtained by <a href="#.getNext"><code>getNext()</code></a> is on a goal.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">bool</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getPath"><span class="type-signature"></span>getPath<span class="signature">(current<span class="signature-attributes">opt</span>, max_path<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {Value}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Gets the path from the current state to a goal.</p>
<ul>
<li>Parameters can also be specified via the ScalarField &quot;current&quot;, &quot;max_path&quot; parameters.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>current</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>
|

<span class="param-type">String</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The actual state value.</p>
<ul>
<li>If omitted considers the previous returned value.</li>
<li>If specified then reset the trajectory.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>max_path</code></td>
            

            <td class="type">
            
                
<span class="param-type">unit</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>0</code>
                
                </td>
            

            <td class="description last"><p>The maximal path length, default is 0 (no bound);</p></td>
        </tr>

    
    </tbody>
</table>














<h5 class="h5-throws">Throws:</h5>

        

    <div class="param-desc usertext">
    
        <p>An <code>illegal-argument</code> exception if at the beginning the value was already on a obstacle.</p>
    
    </div>


    


<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The path sequence of the trajectory towards a goal, avoiding obstacles.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Value</span>



    </dd>
</dl>

    



        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>